/***********************************************************************/
/*                                                                     */
/*  FILE        :intprg.c                                              */
/*  DATE        :Sat, Jan 26, 2013                                     */
/*  DESCRIPTION :Interrupt Program                                     */
/*  CPU TYPE    :H8/3694F                                              */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.8).     */
/*                                                                     */
/***********************************************************************/
                  

/* CN[ht@C錾 */
#include "iodefine.h"
#include "typedefine.h"
#include <machine.h>

/* define錾 */
#define	SOD_BIN		0x42											/* start of data */
#define	SOD_HEX		0x44											/* start of data */
#define EOD			0x45											/* end of data */

#pragma section IntPRG
// vector 1 Reserved

// vector 2 Reserved

// vector 3 Reserved

// vector 4 Reserved

// vector 5 Reserved

// vector 6 Reserved

// vector 7 NMI
__interrupt(vect=7) void INT_NMI(void) {/* sleep(); */}
// vector 8 TRAP #0
__interrupt(vect=8) void INT_TRAP0(void) {/* sleep(); */}
// vector 9 TRAP #1
__interrupt(vect=9) void INT_TRAP1(void) {/* sleep(); */}
// vector 10 TRAP #2
__interrupt(vect=10) void INT_TRAP2(void) {/* sleep(); */}
// vector 11 TRAP #3
__interrupt(vect=11) void INT_TRAP3(void) {/* sleep(); */}
// vector 12 Address break
__interrupt(vect=12) void INT_ABRK(void) {/* sleep(); */}
// vector 13 SLEEP
__interrupt(vect=13) void INT_SLEEP(void) {/* sleep(); */}
// vector 14 IRQ0
__interrupt(vect=14) void INT_IRQ0(void) {/* sleep(); */}
// vector 15 IRQ1
__interrupt(vect=15) void INT_IRQ1(void) {/* sleep(); */}
// vector 16 IRQ2
__interrupt(vect=16) void INT_IRQ2(void) {/* sleep(); */}
// vector 17 IRQ3
__interrupt(vect=17) void INT_IRQ3(void) {/* sleep(); */}
// vector 18 WKP
__interrupt(vect=18) void INT_WKP(void) {/* sleep(); */}
// vector 19 Timer A Overflow
__interrupt(vect=19) void INT_TimerA(void) {/* sleep(); */}
// vector 20 Reserved

// vector 21 Timer W
__interrupt(vect=21) void INT_TimerW(void) {/* sleep(); */}
// vector 22 Timer V
__interrupt(vect=22) void INT_TimerV(void) {/* sleep(); */}
// vector 23 SCI3
__interrupt(vect=23) void INT_SCI3(void)
{
	extern	_UWORD g_input_buf;	
	extern 	_UBYTE g_input_update_req;
	
	extern	_UBYTE stage;												/* Xe[W */
	extern	_UBYTE bin_hex;												/* MtH[@0=binary data  1=hex datab */
	extern	_UWORD input_cal;											/* ̓f[^vZlicmj*/

	
	
	if((SCI3.SSR.BYTE & 0x38) == 0){									/* I[o[At[~OApeB̂ꂩ̃G[H */
	
		switch(SCI3.RDR){
			case SOD_BIN:									  			/* RDR = binarySOD */
				stage = 0;												/* yes ˁ@Xe[W̏ */
				bin_hex = 0x00;											/* binary data̎M@*/
				break;
			
			case SOD_HEX:												/* RDR = hexSOD */
				stage = 0;												/* yes ˁ@Xe[W̏ */
				bin_hex = 0x01;											/* hex data̎M@*/
				break;
			
			case EOD:													/* RDR = EOD */
				if(stage == 4){											/* stage = 4(EOD̎M҂j? */
					g_input_buf = input_cal/10;							/* vZlobt@֓] */
					g_input_update_req = 1;								/* yes ˁ@ɎM@ˁ@Mf[^XVv */
				}
				break;
		
			default:
				if(SCI3.RDR <= 9){
					if(bin_hex == 0){												
												/* bin data̎M */									
						switch(stage){										/* Xe[Wŕ */
							case 0:
								input_cal = SCI3.RDR  * 1000;				/* 1000ʂ̌vZ */
								break;
							case 1:
								input_cal += SCI3.RDR * 100;				/*@100ʂ̌vZ */
								break;
							case 2:
								input_cal += SCI3.RDR * 10;					/*@10ʂ̌vZ */
								break;
							case 3:
								input_cal += SCI3.RDR;						/*@1ʂ̌vZ */
								break;
						}
						++ stage;
					}
				}
				else if(0x30 <= SCI3.RDR <= 0x39){
					if(bin_hex == 1){										
											/* hex data̎M */
						switch(stage){										/* Xe[Wŕ */
							case 0:
								input_cal = (SCI3.RDR & 0x0f) * 1000;		/* 1000ʂ̌vZ */
								break;
							case 1:
								input_cal += (SCI3.RDR &0x0f) * 100;		/*@100ʂ̌vZ */
								break;
							case 2:
								input_cal += (SCI3.RDR &0x0f) * 10;				/*@10ʂ̌vZ */
								break;
							case 3:
								input_cal += (SCI3.RDR &0x0f);						/*@1ʂ̌vZ */
								break;
						}
						++ stage;
					}	
				}
				else{
			
				}
		}
	}
	else{
		SCI3.SSR.BYTE &= 0xC7;										/* I[o[At[~OApeB̃G[̃NA */
	}
}	

// vector 24 IIC2
__interrupt(vect=24) void INT_IIC2(void) {/* sleep(); */}
// vector 25 ADI
__interrupt(vect=25) void INT_ADI(void) {/* sleep(); */}
